	package samples.login.command
	{
		import mx.controls.Alert;
		import mx.rpc.IResponder;
		import mx.rpc.events.FaultEvent;
		import mx.rpc.events.ResultEvent;
		import com.adobe.cairngorm.commands.ICommand;
		import com.adobe.cairngorm.control.CairngormEvent;
		import samples.login.event.LoginEvent;
		import samples.login.business.LoginDelegate;
		import samples.login.model.LoginModelLocator;
		import mx.utils.ObjectUtil;
		import com.adobe.cairngorm.view.ViewLocator;
		import samples.login.vo.UserVO;
		
		public class LoginCommand implements ICommand, IResponder
		{
			private var model : LoginModelLocator = LoginModelLocator.getInstance();
			public function LoginCommand(){}
		
			/**
			 * TemplateMethodパターンによって自動で呼び出されます。
			 */
			public function execute( event : CairngormEvent ): void
			{
				var loginEvent : LoginEvent = LoginEvent( event );
				if( LoginModelLocator.getInstance().user == null)
				{
				    var delegate : LoginDelegate = new LoginDelegate( this );
				    delegate.login(loginEvent.username,loginEvent.password);
				}
				else
				{
					model.statusMessage = "user already login.";
					return;
				}
			}
			
			/**
			 * Serviceの成功イベントとして呼び出されます。
			 */
			public function result( event : Object ) : void
			{	
				var resultEvent:ResultEvent = ResultEvent(event);
				var loginResult:Object = resultEvent.result.login;
				if(loginResult.@result == "OK"){
					model.workflowState = LoginModelLocator.LOGIN_OK;
					model.statusMessage = "login successful.";
					var user:UserVO = new UserVO();
					model.user = user;					
				}else{
					model.workflowState = LoginModelLocator.LOGIN_NG;
					model.statusMessage = "login failure.";
				}
				
			}
		
			/**
			 * Serviceの失敗イベントとして呼び出されます。
			 */
			public function fault( event : Object ) : void
			{
				var faultEvent:FaultEvent = FaultEvent(event);
				var faultString:String = faultEvent.fault.faultString;
				model.statusMessage = "impossible to access. : " + faultString;
			}
		}
	}